import fonctions
import shr

def html_avec_cases(cases, fin = False):
    """ insère les cases dans un fichier html 
        cases contient la liste de liste du plateau de taquin
        l'argument «fin», quand il vaut True, empêche l'affichage des liens sur le plateau (à la fin de la partie)
    """

    fichier="page_vide.html"
    motclé="<!-- PLATEAU -->"

    # lecture du fichier source
    with open (fichier, 'r', encoding="utf-8") as pagevide:
        source_html = pagevide.read()

    # on récupère les candidats
    déplacables = fonctions.candidats(cases)

    #on génère le corps du tableau html
    corps_html=""
    for i in range(len(cases)):
        corps_html += "<tr>"
        for j in range (len(cases[i])):
            if (i,j) in déplacables and not fin:
                corps_html += '<td><a href="/depl?x='+str(i)+'&y='+ str(j) +'">' + str(cases[i][j]) + '</a></td>'
            else:
                corps_html += "<td>" + str(cases[i][j]) + "</td>"
        corps_html += "</tr>"

    # on l'insère dans le fichier source et on renvoie le résultat
    return source_html.replace( motclé, corps_html)

def mouvement(commande, param):
    """ effectue le déplacement et affiche le résultat """

    global cases

    lc = fonctions.candidats(cases)

    # quand on clique sur une case, on appelle un lien du type http://127.0.0.1:5080/depl?x=0&y=3
    # les deux lignes suivantes récupèrent les valeurs de x et y (0 et 3 dans cet exemple)
    x = int(param['x'])
    y = int(param['y'])

    cases = fonctions.échange_zéro(cases, (x,y))

    fin = fonctions.victoire(cases)

    if fin:
        shr.stop()
        
    return html_avec_cases(cases, fin) 

def depart(commande, param):
    return html_avec_cases(cases)
    
if __name__ == '__main__':
    # on initialise le plateau
    cases = fonctions.mélanger(fonctions.gen_cases(4,4),3)

    # on affecte les 2 commandes
    shr.affecter_commande("/", depart)        # permière fenêtre
    shr.affecter_commande("/depl", mouvement) # action effectuée à chaque déplacement

    # démarrage du serveur
    shr.servir()
